<template>
  <div class="row-user">
    <v-row>
      <v-col cols="12" sm="3" md="3">
        {{ item.name }}
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <strong>{{ itemTotalLiters }} л.</strong>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <v-text-field
          label="Жирність"
          :value="itemGreasiness"
          @blur="onChange"
          outlined
          hide-details
          dense
        ></v-text-field>
      </v-col>
      <v-col cols="12" sm="2" md="2" offset="1">
        <strong>{{ itemNewLiters }} л.</strong>
      </v-col>
      <v-col cols="12" sm="2" md="2">
        <strong>{{ itemResult }} грн.</strong>
      </v-col>
    </v-row>
  </div>
</template>

<script>
export default {
  name: "ItemUserRes",

  props: {
    item: {
      type: Object,
      default: () => {}
    },
    date: {
      type: String,
      default: new Date().toISOString().substr(0, 7)
    }
  },

  data: () => ({
    greasiness: 0
  }),

  computed: {
    price() {
      return this.$store.getters["setting/priceForMonth"](this.date);
    },

    itemLiters() {
      if (this.item.records) {
        return this.item.records.reduce((accumulator, currentValue) => {
          const date = new Date(currentValue.date).toISOString().substr(0, 7);
          if (date === this.date) {
            const day = new Date(currentValue.date).toISOString().substr(8, 2);
            if (day <= 15) {
              accumulator.firstPeriod += parseFloat(currentValue.liters);
            } else {
              accumulator.lastPeriod += parseFloat(currentValue.liters);
            }
          }
          return accumulator;
        }, {
          firstPeriod: 0,
          lastPeriod: 0
        });
      }
      return {
          firstPeriod: 0,
          lastPeriod: 0
        };
    },

    itemTotalLiters() {
      return this.itemLiters.firstPeriod + this.itemLiters.lastPeriod;
    },

    itemGreasiness() {
      if (this.item.greasiness) {
        const index = this.item.greasiness.findIndex(item => {
          return this.date === item.date;
        });
        if (index !== -1) {
          return parseFloat(this.item.greasiness[index].value);
        }
      }
      return 0;
    },

    itemNewLiters() {
      const res = (this.itemTotalLiters * this.itemGreasiness) / 3.4;
      return res.toFixed(0);
    },

    itemObjNewLiters() {
      return {
        firstPeriod: (this.itemLiters.firstPeriod * this.itemGreasiness) / 3.4,
        lastPeriod: (this.itemLiters.lastPeriod * this.itemGreasiness) / 3.4
      }
    },

    itemResult() {
      return (this.itemObjNewLiters.firstPeriod * this.price.firstPeriod + this.itemObjNewLiters.lastPeriod * this.price.lastPeriod).toFixed(2);
      // return (this.itemNewLiters * this.price.firstPeriod).toFixed(2);
    }
  },

  methods: {
    async onChange(e) {
      const value = e.target.value;
      this.greasiness = value;
      if (value !== 0) {
        let greasiness = this.item.greasiness ? this.item.greasiness : [];

        const indexRecord = greasiness.findIndex(item => {
          return this.date === item.date;
        });
        if (indexRecord !== -1) {
          greasiness[indexRecord] = {
            value: value,
            date: this.date
          };
        } else {
          greasiness.push({
            value: value,
            date: this.date
          });
        }

        await this.$store.dispatch("user/update", {
          id: this.item._id,
          data: { greasiness }
        });
      }
      this.$emit("update");
    }
  },

  mounted() {
    this.greasiness = this.itemGreasiness;
  }
};
</script>

<style scoped>
.row-user {
  border: 1px solid #ccc;
  margin: 5px;
  padding: 5px;
  border-radius: 10px;
}
</style>
